/* normal keys */
#define kb_ENTER		0x1c0d			/* 7181 */
#define kb_ESCAPE		0x011b			/* 283 */
#define kb_TAB			0x0f09			/* 3849 */
#define kb_SHIFT_TAB		0x0f00			/* 3840 */
#define kb_BACKSPACE		0x0e08			/* 3592 */
#define kb_SLASH		0x352f			/* 13615 */
#define kb_SPACE		0x3920			/* 14624 */

/* misc keys */
#define kb_ALT_EQUAL		0x8300			/* 33536 */
#define kb_ALT_DASH		0x8200			/* 33280 */
#define kb_CTRL_BACKSPACE	0x0e7f			/* 3711 */
#define kb_CTRL_ENTER		0x1c0a			/* 7178 */
#define kb_ALT_SLASH		0x35f0			/* 13808 */
#define kb_ALT_PERIOD		0x34f0			/* 13552 */
#define kb_CTRL_MINUS		0x0c1f			/* 3103 */
#define kb_BIGPLUS		0x4e2b			/* 20011 */
#define kb_BIGMINUS		0x4a2d			/* 18989 */
#define kb_PERIOD		0x342e			/* 13358 */
#define kb_SHIFT_DEL		0x532e			/* 21294 */

/* keypad keys */
#define kb_UP			0x4800			/* 18432 */
#define kb_DOWN			0x5000			/* 20480 */
#define kb_RIGHT		0x4d00			/* 19712 */
#define kb_LEFT			0x4b00			/* 19200 */
#define kb_HOME			0x4700			/* 18176 */
#define kb_END			0x4f00			/* 20224 */
#define kb_PGUP			0x4900			/* 18688 */
#define kb_PGDN			0x5100			/* 20736 */
#define kb_PLUS			0x4e2b			/* 20011 */
#define kb_MINUS		0x4a2d			/* 18989 */
#define kb_INS			0x5200			/* 20992 */
#define kb_DEL			0x5300			/* 21248 */
#define kb_CTRL_PGUP		0x8400			/* 33792 */
#define kb_CTRL_PGDN		0x7600			/* 30208 */
#define kb_SHIFT_UP		0x4838			/* 18488 */
#define kb_SHIFT_DOWN		0x5032			/* 20530 */
#define kb_SHIFT_LEFT		0x4b34			/* 19252 */
#define kb_SHIFT_RIGHT		0x4d36			/* 19766 */
#define kb_SHIFT_PGUP		0x4939			/* 18745 */
#define kb_SHIFT_PGDN		0x5133			/* 20787 */
#define kb_SHIFT_HOME		0x4737			/* 18231 */
#define kb_SHIFT_END		0x4f31			/* 20273 */

/* normal function keys */
#define kb_F1			0x3b00			/* 15104 */
#define kb_F2			0x3c00			/* 15360 */
#define kb_F3			0x3d00			/* 15616 */
#define kb_F4			0x3e00			/* 15872 */
#define kb_F5			0x3f00			/* 16128 */
#define kb_F6			0x4000			/* 16384 */
#define kb_F7			0x4100			/* 16640 */
#define kb_F8			0x4200			/* 16896 */
#define kb_F9			0x4300			/* 17152 */
#define kb_F10			0x4400			/* 17408 */
#define kb_F11			0x8500			/* 34048 */
#define kb_F12			0x8600			/* 34304 */

/* alt-function keys */
#define kb_ALT_F1		0x6800			/* 26624 */
#define kb_ALT_F2		0x6900			/* 26880 */
#define kb_ALT_F3		0x6a00			/* 27136 */
#define kb_ALT_F4		0x6b00			/* 27392 */
#define kb_ALT_F5		0x6c00			/* 27648 */
#define kb_ALT_F6		0x6d00			/* 27904 */
#define kb_ALT_F7		0x6e00			/* 28160 */
#define kb_ALT_F8		0x6f00			/* 28416 */
#define kb_ALT_F9		0x7000			/* 28672 */
#define kb_ALT_F10		0x7100			/* 28928 */
#define kb_ALT_F11		0x8B00			/* 35584 */
#define kb_ALT_F12		0x8C00			/* 35840 */

/* ctrl-key combinations */
#define kb_CTRL_F1		0x5e00			/* 24064 */
#define kb_CTRL_F2		0x5f00			/* 24320 */
#define kb_CTRL_F3		0x6000			/* 24576 */
#define kb_CTRL_F4		0x6100			/* 24832 */
#define kb_CTRL_F5		0x6200			/* 25088 */
#define kb_CTRL_F6		0x6300			/* 25344 */
#define kb_CTRL_F7		0x6400			/* 25600 */
#define kb_CTRL_F8		0x6500			/* 25856 */
#define kb_CTRL_F9		0x6600			/* 26112 */
#define kb_CTRL_F10		0x6700			/* 26368 */
#define kb_CTRL_F11		0x8900			/* 35072 */
#define kb_CTRL_F12		0x8A00			/* 35328 */

/* shift-key combinations */
#define kb_SHIFT_F1		0x5400			/* 21504 */
#define kb_SHIFT_F2		0x5500			/* 21760 */
#define kb_SHIFT_F3		0x5600			/* 22016 */
#define kb_SHIFT_F4		0x5700			/* 22272 */
#define kb_SHIFT_F5		0x5800			/* 22528 */
#define kb_SHIFT_F6		0x5900			/* 22784 */
#define kb_SHIFT_F7		0x5a00			/* 23040 */
#define kb_SHIFT_F8		0x5b00			/* 23296 */
#define kb_SHIFT_F9		0x5c00			/* 23552 */
#define kb_SHIFT_F10		0x5d00			/* 23808 */
#define kb_SHIFT_F11		0x8700			/* 34560 */
#define kb_SHIFT_F12		0x8800			/* 34816 */

/* other alt-key combinations */
#define kb_ALT_A		0x1e00			/* 7680 */
#define kb_ALT_B		0x3000			/* 12288 */
#define kb_ALT_C		0x2e00			/* 11776 */
#define kb_ALT_D		0x2000			/* 8192 */
#define kb_ALT_E		0x1200			/* 4608 */
#define kb_ALT_F		0x2100			/* 8448 */
#define kb_ALT_G		0x2200			/* 8704 */
#define kb_ALT_H		0x2300			/* 8960 */
#define kb_ALT_I		0x1700			/* 5888 */
#define kb_ALT_J		0x2400			/* 9216 */
#define kb_ALT_K		0x2500			/* 9472 */
#define kb_ALT_L		0x2600			/* 9728 */
#define kb_ALT_M		0x3200			/* 12800 */
#define kb_ALT_N		0x3100			/* 12544 */
#define kb_ALT_O		0x1800			/* 6144 */
#define kb_ALT_P		0x1900			/* 6400 */
#define kb_ALT_Q		0x1000			/* 4096 */
#define kb_ALT_R		0x1300			/* 4864 */
#define kb_ALT_S		0x1f00			/* 7936 */
#define kb_ALT_T		0x1400			/* 5120 */
#define kb_ALT_U		0x1600			/* 5632 */
#define kb_ALT_V		0x2f00			/* 12032 */
#define kb_ALT_W		0x1100			/* 4352 */
#define kb_ALT_X		0x2d00			/* 11520 */
#define kb_ALT_Y		0x1500			/* 5376 */
#define kb_ALT_Z		0x2c00			/* 11264 */

#define kb_ALT_1		0x7800			/* 30720 */
#define kb_ALT_2		0x7900			/* 30976 */
#define kb_ALT_3		0x7A00			/* 31232 */
#define kb_ALT_4		0x7B00			/* 31488 */
#define kb_ALT_5		0x7C00			/* 31744 */
#define kb_ALT_6		0x7D00			/* 32000 */
#define kb_ALT_7		0x7E00			/* 32256 */
#define kb_ALT_8		0x7F00			/* 32512 */
#define kb_ALT_9		0x8000			/* 32768 */
#define kb_ALT_0		0x8100			/* 33024 */

/* misc ctrl-key combinations */
#define kb_CTRL_A		0x1e01			/* 7681 */
#define kb_CTRL_B		0x3002			/* 12290 */
#define kb_CTRL_C		0x2e03			/* 11779 */
#define kb_CTRL_D		0x2004			/* 8196 */
#define kb_CTRL_E		0x1205			/* 4613 */
#define kb_CTRL_F		0x2106			/* 8454 */
#define kb_CTRL_G		0x2207			/* 8711 */
#define kb_CTRL_H		0x2308			/* 8968 */
#define kb_CTRL_I		0x1709			/* 5897 */
#define kb_CTRL_J		0x240a			/* 9226 */
#define kb_CTRL_K		0x250b			/* 9483 */
#define kb_CTRL_L		0x260c			/* 9740 */
#define kb_CTRL_M		0x320d			/* 12813 */
#define kb_CTRL_N		0x310e			/* 12558 */
#define kb_CTRL_O		0x180f			/* 6159 */
#define kb_CTRL_P		0x1910			/* 6416 */
#define kb_CTRL_Q		0x1011			/* 4113 */
#define kb_CTRL_R		0x1312			/* 4882 */
#define kb_CTRL_S		0x1f13			/* 7955 */
#define kb_CTRL_T		0x1414			/* 5140 */
#define kb_CTRL_U		0x1615			/* 5653 */
#define kb_CTRL_V		0x2f16			/* 12054 */
#define kb_CTRL_W		0x1117			/* 4375 */
#define kb_CTRL_X		0x2d18			/* 11544 */
#define kb_CTRL_Y		0x1519			/* 5401 */
#define kb_CTRL_Z		0x2c1a			/* 11290 */

/* special keys not returned by the BIOS */
#define kb_ALT_TAB		0xB000			/* 45056 */
#define kb_ALT_SPACE		0xB200			/* 45568 */
#define kb_ALT_BACKSPACE	0xB400			/* 46080 */
#define kb_CTRL_ALT		0xB500			/* 46336 */
#define kb_BOTHSHIFTS		0xB800			/* 47104 */
#define kb_CTRL_EQUAL		0xB900			/* 47360 */
#define kb_CTRL_INSERT		0xBA00			/* 47616 */
#define kb_ALT_SHIFT		0xBB00			/* 47872 */
#define kb_CTRL_1		0xBC00			/* 48128 */
#define kb_CTRL_2		0xBC01			/* 48129 */
#define kb_CTRL_3		0xBC02			/* 48130 */
#define kb_CTRL_4		0xBC03			/* 48131 */
#define kb_CTRL_5		0xBC04			/* 48132 */
#define kb_CTRL_6		0xBC05			/* 48133 */
#define kb_CTRL_7		0xBC06			/* 48134 */
#define kb_CTRL_8		0xBC07			/* 48135 */
#define kb_CTRL_9		0xBC08			/* 48136 */
#define kb_CTRL_0		0xBC09			/* 48137 */
#define kb_CTRL_DEL		0xC600			/* 50688 */
#define kb_CTRL_SHIFT_UP	0xC700			/* 50944 */
#define kb_CTRL_SHIFT_DOWN	0xC800			/* 51200 */
#define kb_CTRL_SHIFT_LEFT	0xC900			/* 51456 */
#define kb_CTRL_SHIFT_RIGHT	0xCA00			/* 51712 */
#define kb_CTRL_RIGHT		0xCB00			/* 51968 */
#define kb_CTRL_LEFT		0xCD00			/* 52480 */
#define kb_CTRL_UP		0xCF00			/* 52992 */
#define kb_CTRL_DOWN		0xD000			/* 53248 */
#define kb_CTRL_CENTER		0xD100			/* 53504 */
#define kb_CENTER		0xD200			/* 53760 */
#define kb_CTRL_HOME		0xD300			/* 54016 */
#define kb_CTRL_END		0xD400			/* 54272 */
#define kb_CTRL_SHIFT_HOME	0xD500			/* 54528 */
#define kb_CTRL_SHIFT_END 	0xD600			/* 54784 */
#define kb_CTRL_SHIFT_I		0xD900			/* 55552 */
#define kb_SPACEPRESS		0xDA00			/* 55808 */
#define kb_CTRL_BIGPLUS		0xDC00			/* 56320 */
#define kb_CTRL_BIGMINUS	0xDD00			/* 56576 */
#define kb_ALT_ESC		0xDE00			/* 56832 */
#define kb_SHIFT_INSERT		0xDF00			/* 57088 */
#define kb_CTRL_SHIFT_PGUP	0xE000			/* 57344 */
#define kb_CTRL_SHIFT_PGDN	0xE100			/* 57600 */
#define kb_ALT			0xE200			/* 57856 */
#define kb_CTRL			0xE300			/* 58112 */
#define kb_CTRL_TAB		0xE400			/* 58368 */
