#include <ctype.h>

#include "extern.h"		/* Extensions need these! */

/*
** This keyboard hook filters all alphabetic characters, passing only
** the upper case equivalents.
**
** Keyboard hooks must save the DS register.
*/
WORD _loadds trap(WORD KeyWord)

{
	WORD w;

	w = KeyWord & 0x00FF;	/* w = ASCII code */

	if (w) {
	    if (isalpha(w)) return((KeyWord & 0xFF00) | toupper(w));
	}

	return(KeyWord);
}

startHook()

{
	SetKeyHook(trap);
	return(STOP);
}

stopHook()

{
	SetKeyHook(NULL);
	return(STOP);
}

/*
** Remove the keyboard hook when the extension is removed from memory.
*/
pascal far WhenUnLoaded()

{
	stopHook();
}

POOL pascal Pool[] = {

	{	"startHook",
		startHook,
		0,
		HANDLER},

	{	"stopHook",
		stopHook,
		0,
		HANDLER},

	{	NULL,			/* NULLs signify the end of the table */
		NULL,
		0,
		0}	};
