#include <stdarg.h>
#include <dos.h>
#include <ctype.h>

#include "extern.h"

extern int far GX2LOAD(char far *,int,int );
extern savemouse();
extern restoremouse();
extern hide();
extern show();
extern button();

/*
** This routine displays a .GX2 picture and wait for a key or a mouse press.
** because mode switches destroy the current mouse settings, this routine
** first saves the mouse using an undocumented mouse call, then shows the
** picture, then waits for a key or mouse press, then resets the original
** mouse parameters. There is an optional second parameter specifying a
** timeout.
**
**	loadGX2 <filename> [,<timeout>]
**
** Parameters:
**
**	fileName		full DOS filename, including an extension
**	[timeout]		optional time parameter. If specified, the
**				picture will be removed after this many
**				milliseconds.
**
** Examples:
**
**	loadgx2 "baseball.gx2";		-- wait for key or mouse event
**	loadgx2 "baseball.gx2",1000;	-- wait 1 second (or mouse/key event)
*/
LoadGX2(int NumArgs,HANDLE hFileName,HANDLE hStopData)

{
	SHAREDPTR pShared;
	PACKETPTR Screen;
	MSG msg;
	PTR p;
	DWORD endtime;

	if (NumArgs < 1) return(STOP);

	pShared = GetSharedArea();
	Screen = pShared -> pVideoModes[0];

	savemouse();

	if (!GX2LOAD(	deref(hFileName),		/* file name */
			pShared -> CardType[0],		/* card type */
			pShared -> MonitorType[0]	/* monitor type */
		)) {

	    endtime = (NumArgs == 2) ? GetTime() + (htoi(hStopData) / 55) : 0;

	    show();
	    do {
	        GetEvent(&msg);
		if (endtime) if (GetTime() > endtime) break;
	    } while (msg.Event != EVENT_KEYPRESS && !button());

	    /* wait until the mouse buttons are released */
	    while (button());

	    /* hide the mouse */
	    hide();

	}

	(*Screen -> SetMode)();

	Refresh();

	restoremouse();
	
	return(STOP);
}

POOL pascal Pool[] = {
	{	"LoadGX2",
		LoadGX2,
		0,
		HANDLER},

	{	NULL,
		NULL,
		0,
		0}	};

